#pragma once

#include <a8/args.h>

namespace a8
{
    typedef long long tick_t;
    struct XTimerPtr;

    struct SendQueueNode
    {
        char* buff;
        unsigned int bufflen;
        unsigned int sent_bytes;
        SendQueueNode* next;
    };

    typedef std::function<void(const a8::Args&)> CommonCbProc;
    typedef std::function<void(const a8::Args*)> CommonCbProcEx;
    typedef std::weak_ptr<struct XTimerPtr> XTimerWp;
    typedef std::function<void(int, const a8::Args*)> TimerCb;

    namespace reflect
    {
        class Class;
    }

    const int INVALID_FD = -1;
    const int INVALID_SOCKET = -1;
    const int INVALID_SOCKET_HANDLE = 0;

    const int TIMER_EXEC_EVENT = 1;
    const int TIMER_DELETE_EVENT = 2;
    const int TIMER_DESTORY_EVENT = 3;
    const int TIMER_USER_EVENT = 66;

    const float A8_PI = 3.1415926f;
};

template<typename T>
const char* GetEnumString()
{
    return nullptr;
};

namespace std
{
    class thread;
    class condition_variable;
    class mutex;
}
