#pragma once

namespace f8
{

    class UserApp;
    class App
    {
        A8_DECLARE_SINGLETON(App);
    public:

        int Run(int argc, char* argv[], UserApp* user_app);

        const std::string GetPkgName();
        void NotifyLoopCond();
        bool HasFlag(int flag);
        long long NewNodeUuid();
        const std::string NewGlobalUuid();
        int GetZoneId();
        int GetNodeId();
        int GetInstanceId();
        int GetNowTime();
        int GetPid();
        bool Terminated();
        void Terminate();
        void AddSocketMsg(unsigned short sockfrom,
                          long long socket_handle,
                          int msgid,
                          int seqid,
                          const char *buf,
                          int buflen,
                          const char *playload,
                          int playload_len,
                          unsigned short tag);
        char** GetArgv();
        int GetArgc();
        long long GetMsgNodeSize();
        long long GetWorkingMsgNodeSize();
        long long GetMaxRunDelayTime();
        void ResetMaxRunDelayTime();

    private:
        class Impl;
        std::unique_ptr<Impl> impl_;
    };

}
