#pragma once

#include <asio.hpp>

namespace f8
{

    class IoMgr
    {
        A8_DECLARE_SINGLETON(IoMgr);
    public:

        void Init();
        void UnInit();
        void Update();
        std::shared_ptr<asio::io_context> GetIoContext(int type);

    private:
        void WorkerThreadProc(std::shared_ptr<asio::io_context> io_context);

    private:
        std::vector<std::vector<std::shared_ptr<asio::io_context::work>>> io_works_;
        std::vector<std::vector<std::shared_ptr<asio::io_context>>> io_contexts_;
        friend class TcpClient;
    };

}
