#include <f8/internal/pch.h>

#include <cstring>

#include <f8/msghdr.h>

namespace f8
{

    char* MsgHdr::GetBodyData() const
    {
        return (char*)this + sizeof(MsgHdr);
    }

    int MsgHdr::GetBodyLen() const
    {
        return buflen;
    }

    char* MsgHdr::GetPlayloadData() const
    {
        return (char*)this + sizeof(MsgHdr) + GetBodyLen();
    }

    int MsgHdr::GetPlayloadLen() const
    {
        return payload_buflen;
    }

    MsgHdr* MsgHdr::Clone()
    {
        MsgHdr* hdr = (MsgHdr*)malloc(sizeof(MsgHdr) + buflen);
        memmove((void*)hdr, (void*)this, sizeof(MsgHdr) + buflen);
        if (processed_data) {
            hdr->processed_data = new(std::any);
            *hdr->processed_data = *processed_data;
        }
        return hdr;
    }

    void MsgHdr::Destroy(MsgHdr* hdr)
    {
        if (hdr->processed_data) {
            delete hdr->processed_data;
            hdr->processed_data = nullptr;
        }
        free((void*)hdr);
    }

}
