#pragma once

namespace f8
{
    namespace internal
    {
        class AsioTcpClient;
    }
}

namespace f8
{

    using TcpClientImpl = f8::internal::AsioTcpClient;

    class TcpClient
    {
    public:
        std::function<void (f8::TcpClient*, int)> on_error;
        std::function<void (f8::TcpClient*)> on_connect;
        std::function<void (f8::TcpClient*, int)> on_disconnect;
        std::function<void (f8::TcpClient*, char*, int)> on_read;

    public:

        TcpClient(const std::string& remote_ip, int remote_port);
        virtual ~TcpClient();
        const std::string& GetRemoteAddress();
        int GetRemotePort();

        void Open();
        void Close();
        bool Connected();
        void SendBuff(const char* buff, int bufflen);

    private:
        std::shared_ptr<TcpClientImpl> impl_;

    };

}
