#pragma once

namespace f8
{
    namespace internal
    {
        class AsioTcpListener;
    }
}

namespace f8
{

    using TcpListenerImpl = f8::internal::AsioTcpListener;

    class TcpSession;
    class TcpListener
    {
    public:
        std::function<void (f8::TcpListener*, f8::TCPLISTENER_E, int)> on_error;

    public:
        TcpListener(int max_client_cnt=0xEFFF);
        virtual ~TcpListener();

        void Open();
        void Close();
        template <typename T>
        void RegisterSessionClass()
        {
            on_create_client_socket_ =
                [] (f8::TcpSession** p)
                {
                    *p = new T;
                };
        }

    private:
        f8::TcpListenerImpl* impl_ = nullptr;

        friend class f8::TcpSession;
        friend class f8::TcpListenerImpl;
    };

}
